package main

import (
	"time"
	"net/http"
	"github.com/gin-gonic/gin"
	"golang.org/x/sync/errgroup"
)

type GinMgr struct {
	group errgroup.Group
}

func (this *GinMgr) init() {
	server01 := &http.Server{
		Addr:         ":8080",
		Handler:      this.router(),
		ReadTimeout:  5 * time.Second,
		WriteTimeout: 10 * time.Second,
	}
	this.group.Go(func() error {
		return server01.ListenAndServe()
	})
}

func (this *GinMgr) unInit() {
}

func (this *GinMgr) router() http.Handler {
	r := gin.New()
	r.Use(gin.Recovery())
	r.GET("/webapp/index.php", func(c *gin.Context) {
		c.JSON(200, gin.H{
			"errcode": 0,
			"errmsg": "",
		})
	})
	return r
}
