package main

import (
	"fmt"
	"testing"
)

func TestRegisterUser(t *testing.T) {
	fm := &FriendsMgr{}
	// Make
	fm.users = make(map[string]*User, 10)
	fm.searchCaches = make(map[string]SearchCache, 10)
	fm.friendships = make(map[string][]*Friendship, 10)

	// Register users
	fm.registerUser("1", "google")
	fm.registerUser("2", "apple")
	fm.registerUser("3", "sony")
	fm.registerUser("4", "panasonic")
	fm.registerUser("5", "nec")
	fm.registerUser("6", "ntt")
	for i := 7; i <= 10; i++ {
		fm.registerUser(fmt.Sprint(i), RandomUsername())
	}
	fmt.Printf("users: %d \n", len(fm.users))

	// Search users
	keyword := "a"
	searchResult := fm.searchUsers(keyword)
	fmt.Printf("search [%s] count: %d \n", keyword, len(searchResult))
	PrintUsers("search result", searchResult)

	// Add friend request
	// google 申请添加 apple 好友
	//fmt.Printf("after: pendingReqs count: %d \n", len(fm.pendingReqs))
	//fm.addFriendRequest("1", "2")
	//fm.addFriendRequest("3", "2")
	//fm.addFriendRequest("4", "2")
	//fm.addFriendRequest("5", "6")
	//fm.addFriendRequest("6", "2")
	//fmt.Printf("before: pendingReqs count: %d \n", len(fm.pendingReqs))

	// Accept friend requests
	//fm.acceptFriendRequest("2", "1")
	//fm.acceptFriendRequest("2", "3")
	//fm.acceptFriendRequest("2", "4")
	//fm.rejectFriendRequest("2", "6")
	//fm.acceptFriendRequest("6", "5")

	// Get friends
	googleFriends := fm.listFriends("1")
	PrintUsers("googleFriends", googleFriends)

	appleFriends := fm.listFriends("2")
	PrintUsers("appleFriends", appleFriends)

	necFriends := fm.listFriends("5")
	PrintUsers("necFriends", necFriends)
}

func PrintUsers(str string, userList []*User) {
	for _, user := range userList {
		fmt.Printf("[%s]:accountId:%s, username:%s \n", str, user.accountId, user.username)
	}
}

func (fm *FriendsMgr) registerUser(accountId string, username string) error {
	if fm.users[accountId] == nil {
		fm.users[accountId] = &User{accountId: accountId, username: username}
		return nil
	}
	return fmt.Errorf("user exists")
}
