package main

import (
	"f5"
	"fmt"
	"q5"
	"testing"
)

var (
	leaderId  = "6513_2006_test134345"
	member1Id = "6513_2006_111"
	member2Id = "6513_2006_222"
)

var newGuildId int64 = 1148210928160867328

func TestInit(t *testing.T) {
	f5.Run(app)
	fmt.Printf("test init")
}

func TestCreateGuild(t *testing.T) {
	f5.Run(app)

	guildMgr := NewGuildMgr()
	guildMgr.CreateGuild(
		randomGuildName(),
		leaderId,
		func(errCode int32, errMsg string, guildId int64) {
			newGuildId = guildId
			fmt.Println("Created guild:", guildId)
		})
}

func TestGuildMember(t *testing.T) {
	guildMgr.ApplyToGuild(
		newGuildId, member1Id,
		func(errCode int32, errMsg string) {
			if errCode != 0 {
				t.Errorf("Error:%s", errMsg)
			}
			fmt.Println("Applied to guild")
		},
	)
}

func randomGuildName() string {
	return q5.RandomString(6)
}
